// avfsavi.cpp : Avisynth Virtual File System
//
// Avisynth v2.5.  Copyright 2008 Ben Rudiak-Gould et al.
// http://www.avisynth.org

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .
//
// Linking Avisynth statically or dynamically with other modules is making a
// combined work based on Avisynth.  Thus, the terms and conditions of the GNU
// General Public License cover the whole combination.
//
// As a special exception, the copyright holders of Avisynth give you
// permission to link Avisynth with independent modules that communicate with
// Avisynth solely through the interfaces defined in avisynth.h, regardless of the license
// terms of these independent modules, and to copy and distribute the
// resulting combined work under terms of your choice, provided that
// every copy of the combined work is accompanied by a complete copy of
// the source code of Avisynth (the version of Avisynth used to produce the
// combined work), being distributed under the terms of the GNU General
// Public License plus this exception.  An independent module is a module
// which is not derived from or based on Avisynth, such as 3rd-party filters,
// import and export plugins, or graphical user interfaces.


#include "avfsincludes.h"

#if 0
RIFFLIST          DWORD    riff;               /* 'RIFF' */
 .                DWORD    rifflen;            /* len-8    0x0092AB44 9612100 */
 .                DWORD    avi;                /* 'AVI ' */
 RIFFLIST           DWORD    list;             /* 'LIST' */
  .                 DWORD    listlen;          /* 0x00002270 8816 */
  .                 DWORD    hdrl;             /* 'hdrl' */
  AVIMAINHEADER       DWORD    avih;           /* 'avih' */
   .                  DWORD    avihlen;        /* 0x00000038 56 */
   .                  DWORD    dwMicroSecPerFrame;
   .                  DWORD    dwMaxBytesPerSec;
   .                  DWORD    dwPaddingGranularity;
   .                  DWORD    dwFlags;
   .                  DWORD    dwTotalFrames;
   .                  DWORD    dwInitialFrames;
   .                  DWORD    dwStreams;
   .                  DWORD    dwSuggestedBufferSize;
   .                  DWORD    dwWidth;
   .                  DWORD    dwHeight;
   .                  DWORD    dwReserved[4];
  RIFFLIST            DWORD    list;             /* 'LIST' */
   .                  DWORD    listlen;          /* 0x00001094 4244 */
   .                  DWORD    strl;             /* 'strl' */
   AVISTREAMHEADER      DWORD    strh;           /* 'strh' */
    .                   DWORD    strhlen;        /* 0x00000038 56 */
    .                   DWORD    fccType_stream_type; /* 'vids' */
    .                   DWORD    fccType_stream_handler;
    .                   DWORD    dwFlags;
    .                   WORD     wPriorty;
    .                   WORD     wLanguage;
    .                   DWORD    dwInitialFrames;
    .                   DWORD    dwScale;
    .                   DWORD    dwRate;
    .                   DWORD    dwStart;
    .                   DWORD    dwLength;
    .                   DWORD    dwSuggestedBufferSize;
    .                   DWORD    dwQuality;
    .                   DWORD    dwSampleSize;
    .                   WORD     rcFrame.left;
    .                   WORD     rcFrame.top;
    .                   WORD     rcFrame.right;
    .                   WORD     rcFrame.bottom;
   RIFFCHUNK            DWORD    strf;           /* 'strf' */
    .                   DWORD    strflen;        /* 0x00000028 40 */
    BITMAPINFOHEAD
   RIFFCHUNK            DWORD    junk;           /* 'JUNK' */
    .                   DWORD    junklen;        /* 0x00001018 4120 */
    BYTE[4120]            BYTE[4120] padding;    
  RIFFLIST            DWORD    list;             /* 'LIST' */
   .                  DWORD    listlen;          /* 0x00001094 4220 */
   .                  DWORD    strl;             /* 'strl' */
   AVISTREAMHEADER      DWORD    strh;           /* 'strh' */
    .                   DWORD    strhlen;        /* 0x00000038 56 */
    .                   DWORD    fccType_stream_type; /* 'auds' */
    .                   DWORD    fccType_stream_handler;
    .                   DWORD    dwFlags;
    .                   WORD     wPriorty;
    .                   WORD     wLanguage;
    .                   DWORD    dwInitialFrames;
    .                   DWORD    dwScale;
    .                   DWORD    dwRate;
    .                   DWORD    dwStart;
    .                   DWORD    dwLength;
    .                   DWORD    dwSuggestedBufferSize;
    .                   DWORD    dwQuality;
    .                   DWORD    dwSampleSize;
    .                   WORD     rcFrame.left;
    .                   WORD     rcFrame.top;
    .                   WORD     rcFrame.right;
    .                   WORD     rcFrame.bottom;
   RIFFCHUNK            DWORD    strf;           /* 'strf' */
    .                   DWORD    strflen;        /* 0x00000028 16 */
    PCMWAVEFORMAT
or
    WAVEFORMAT + WORD
                      // typedef struct tWAVEFORMATEX
                          WORD   wFormatTag;         /* format type */
                          WORD   nChannels;          /* number of channels (i.e. mono, stereo...) */
                          DWORD  nSamplesPerSec;     /* sample rate */
                          DWORD  nAvgBytesPerSec;    /* for buffer estimation */
                          WORD   nBlockAlign;        /* block size of data */
                          WORD   wBitsPerSample;     /* number of bits per sample of mono data */
                      //  WORD   cbSize;             /* the count in bytes of the size of */
                      //                             /* extra information (after cbSize) */

   RIFFCHUNK            DWORD    junk;           /* 'JUNK' */
    .                   DWORD    junklen;        /* 0x00001018 4120 */
    BYTE[4120]            BYTE[4120] padding;    
  RIFFLIST            DWORD    list;             /* 'LIST' */
   .                  DWORD    listlen;          /* 0x00000104 260 */
   .                  DWORD    odml;             /* 'odml' */
   AVIEXTHEADER         DWORD    dmlh;           /* 'dmlh' */
    .                   DWORD    dmlhlen;        /* 0x000000F8 248 */
    .                   DWORD dwGrandFrames;     /* 0x0000003C 60 */
    .                   DWORD[61] padding;    
 RIFFCHUNK          DWORD    junk;               /* 'JUNK' */
  .                 DWORD    junklen;            /* 0x00000574 1396 */
  BYTE[1396]          BYTE[1396] padding;       /* "VirtualDub build 24442/release" */
 RIFFLIST           DWORD    list;               /* 'LIST' */
  .                 DWORD    listlen;            /* 0x00927F6C 9600876 */
  .                 DWORD    movi;               /* 'movi' */
  RIFFCHUNK           DWORD    00dc;             /* '00dc' */
   .                  DWORD    00dclen;          /* 0x00025800 153600 */
   BYTE[153600]         BYTE[153600] dataV;     /* Frame 0 */
  RIFFCHUNK           DWORD    00dc;             /* '00dc' */
   .                  DWORD    00dclen;          /* 0x00025800 153600 */
   BYTE[153600]         BYTE[153600] dataV;     /* Frame 1 */
....              
  RIFFCHUNK           DWORD    01wb;             /* '1wbc' */
   .                  DWORD    01wblen;          /* 0x0005DD80 384384 */
   BYTE[384384]         BYTE[384384] dataA;     /* Audio */
 AVIOLDINDEX        DWORD    idx1;               /* 'idx1' */
  .                 DWORD    idx1len;            /* 0x000003D0 976 */
  .                 DWORD    type;               /* '00dc' */
  .                 DWORD    flags;              /* 0x00000010 */
  .                 DWORD    offset;             /* 0x00000004 */
  .                 DWORD    length;             /* 0x00025800 */
  .                 DWORD    type;               /* '00dc' */
  .                 DWORD    flags;              /* 0x00000010 */
  .                 DWORD    offset;             /* 0x0002580C */
  .                 DWORD    length;             /* 0x00025800 */
....
  .                 DWORD    type;               /* '00dc' */
  .                 DWORD    flags;              /* 0x00000010 */
  .                 DWORD    offset;             /* 0x008A49DC */
  .                 DWORD    length;             /* 0x00025800 */
  .                 DWORD    type;               /* '01wb' */
  .                 DWORD    flags;              /* 0x00000010 */
  .                 DWORD    offset;             /* 0x008CA1E4 */
  .                 DWORD    length;             /* 0x0005DD80 */
 RIFFCHUNK          DWORD    junk;               /* 'JUNK' */
  .                 DWORD    junklen;            /* 0x0000000? 1828 */
  BYTE[1828]          BYTE[1828] padding;
#endif

#include <aviriff.h>

static const int fileHdrSize = 10240; /* Avoid snoopy MP3 player problems */

//    Avi file layout :- File Length 0x0092AB4C 9612108
struct fileHdr {
  RIFFLIST                  riff;      /* 'RIFF' 'AVI ' */
    RIFFLIST                hdrl;      /* 'LIST' 'hdrl' */
      AVIMAINHEADER         avih;      /* 'avih' ckidMAINAVIHEADER */

      RIFFLIST              strlv;     /* 'LIST' 'strl' ckidSTREAMLIST */
        AVISTREAMHEADER     strhv;     /* 'strh' ckidSTREAMHEADER streamtypeVIDEO */
        RIFFCHUNK           strfv;     /* 'strf' ckidSTREAMFORMAT */
          BITMAPINFOHEADER  video;

      RIFFLIST              strla;     /* 'LIST' 'strl' ckidSTREAMLIST */
        AVISTREAMHEADER     strha;     /* 'strh' ckidSTREAMHEADER streamtypeAUDIO */
        RIFFCHUNK           strfa;     /* 'strf' ckidSTREAMFORMAT */
          PCMWAVEFORMAT     audio;     /* cast to WAVEFORMATEX */

      RIFFLIST              odml;      /* 'LIST' 'odml' ckidODML */
        AVIEXTHEADER        dmlh;      /* 'dmlh' ckidAVIEXTHEADER */

    RIFFCHUNK               junk;      /* 'JUNK' */
};
#if 0
      BYTE[1396]            padding;   /* "VirtualDub build 24442/release" */

    RIFFLIST                movi;      /* 'LIST' 'movi' */
      RIFFCHUNK             00dc;      /* '00dc' */
        BYTE[153600]        dataV;     /* Frame 0 */
      RIFFCHUNK             00dc;      /* '00dc' */
        BYTE[153600]        dataV;     /* Frame 1 */
...              
      RIFFCHUNK             00dc;      /* '00dc' */
        BYTE[153600]        dataV;     /* Frame last */
      RIFFCHUNK             01wb;      /* '1wbc' */
        BYTE[384384]        dataA;     /* Audio */
    AVIOLDINDEX             idx1;      /* 'idx1' ckidAVIOLDINDEX */
#endif


DWORD pixelTypeToFCC(
  int pixel_type)
{
    switch (pixel_type) {
      case VideoInfo::CS_BGR24:
        return FCC('DIB ');
      case VideoInfo::CS_BGR32:
        return FCC('DIB ');
      case VideoInfo::CS_YUY2:
        return FCC('YUY2');
      case VideoInfo::CS_YV12:
        return FCC('YV12');
      case VideoInfo::CS_I420:
        return FCC('I420');
      default:
        return FCC('UNKN');
    }
}


inline bool/*all done*/ copyBuffer(
  char*    &Buffer,
  unsigned &fileOffset,
  unsigned &requestedSize,
  size_t   inSize,
  void     *srcBuffer)
{
  if (fileOffset < inSize) {
    const unsigned size = min(inSize - fileOffset, requestedSize);
    memcpy(Buffer, reinterpret_cast<char*>(srcBuffer)+fileOffset, size);
    Buffer += size;
    fileOffset += size;
    requestedSize -= size;
  }
  fileOffset -= inSize;
  return (requestedSize == 0);
}


inline bool/*all done*/ fillBuffer(
  char*    &Buffer,
  unsigned &fileOffset,
  unsigned &requestedSize,
  size_t   inSize)
{
  if (fileOffset < inSize) {
    const unsigned size = min(inSize - fileOffset, requestedSize);
    memset(Buffer, '\0', size);
    Buffer += size;
    fileOffset += size;
    requestedSize -= size;
  }
  fileOffset -= inSize;
  return (requestedSize == 0);
}


inline bool/*all done*/ copyPlane(
  char*        &buffer,
  unsigned     &offset,
  unsigned     &rqsize,
  PVideoFrame  &frame,
  int          plane,
  unsigned     align)
{
  const unsigned rowsize = (frame->GetRowSize(plane) + align) & ~align;
  const unsigned plsize  = frame->GetHeight(plane) * rowsize;
  const unsigned pitch   = frame->GetPitch(plane);

  if (offset < plsize) {
    unsigned size = min(plsize - offset, rqsize);

    const BYTE* data = frame->GetReadPtr(plane);

    data += (offset / rowsize) * pitch;
    unsigned initoff = offset % rowsize;
    offset += size;
    rqsize -= size;

    while (size > 0) {
      unsigned xfer = min(rowsize-initoff, size);
      memcpy(buffer, data+initoff, xfer);
      buffer += xfer;
      size   -= xfer;
      data   += pitch;
      initoff = 0;
    }
  }
  offset -= plsize;
  return (rqsize == 0);
}


struct AvfsAviFile:
   AvfsMediaFile_
{
  int references;
  Avisynther_* avs;
  int frameOffset;
  unsigned videoDataSize;
  unsigned idx1DataSize;

  fileHdr avifx;
  RIFFLIST movi;
  RIFFCHUNK v00dc, a01wb;

  AVIOLDINDEX *idx1;

  enum { maxAlign = 128 }; /* Upto 32 channels of 32bit samples */

  AvfsAviFile(
    Avisynther_* avs,
    int offset,
    int frames);
  ~AvfsAviFile(void);
  void AddRef(void);
  void Release(void);
  bool/*success*/ ReadMedia(
    AvfsLog_* log,
    uint64_t fileOffset,
    void* buffer,
    size_t requestedSize);
  uint64_t fileSize(void);
  bool/*success*/ frameCopy(
    AvfsLog_* log,
    char* buffer,
    int n,
    unsigned offset,
    unsigned size);
  bool/*all done*/ copyVideo(
    char*        &Buffer,
    unsigned     &fileOffset,
    unsigned     &requestedSize,
    size_t       inSize,
    AvfsLog_*    log,
    bool         &success);
  bool/*all done*/ copyAudio(
    char*        &Buffer,
    unsigned     &fileOffset,
    unsigned     &requestedSize,
    size_t       inSize,
    AvfsLog_*    log,
    bool         &success);
};


AvfsAviFile::AvfsAviFile(
  Avisynther_* inAvs,
  int inOffset,
  int inFrames)
{
  references = 1;
  avs = inAvs;
  avs->AddRef();
  frameOffset = inOffset;

  const VideoInfo& vi = avs->GetVideoInfo();

  memset(&avifx, '\0', sizeof(avifx));
  // Build file prefix data
  avifx.riff.fcc = FCC('RIFF');
  avifx.riff.cb = 0; // filelength - 8
  avifx.riff.fccListType = FCC('AVI ');
//-----
  avifx.hdrl.fcc = FCC('LIST');
  avifx.hdrl.cb = 4 + sizeof(avifx.avih)
                    + sizeof(avifx.strlv) + sizeof(avifx.strhv)
                    + sizeof(avifx.strfv) + sizeof(avifx.video)
                    + sizeof(avifx.strla) + sizeof(avifx.strha)
                    + sizeof(avifx.strfa) + sizeof(avifx.audio)
                    + sizeof(avifx.odml)  + sizeof(avifx.dmlh);
  avifx.hdrl.fccListType = FCC('hdrl');
//-----
  avifx.avih.fcc = ckidMAINAVIHEADER;
  avifx.avih.cb = sizeof(AVIMAINHEADER) - 8;
  avifx.avih.dwMicroSecPerFrame = MulDiv(1000000, vi.fps_denominator, vi.fps_numerator);
  avifx.avih.dwFlags = AVIF_HASINDEX;
  avifx.avih.dwTotalFrames = inFrames;
  avifx.avih.dwStreams = 2 ; // (vi.HasVideo() ? 1 : 0) + (vi.HasAudio() ? 1 : 0);
  avifx.avih.dwWidth = vi.width;
  avifx.avih.dwHeight = vi.height;
//-----
// Video
//-----
  avifx.strlv.fcc = FCC('LIST');
  avifx.strlv.cb = 4 + sizeof(avifx.strhv) + sizeof(avifx.strfv) + sizeof(avifx.video);
  avifx.strlv.fccListType = ckidSTREAMLIST;
//-----
  avifx.strhv.fcc = ckidSTREAMHEADER;
  avifx.strhv.cb = sizeof(AVISTREAMHEADER) - 8;
  avifx.strhv.fccType = streamtypeVIDEO;
  avifx.strhv.fccHandler = pixelTypeToFCC(vi.pixel_type);
  avifx.strhv.dwScale = vi.fps_denominator;
  avifx.strhv.dwRate = vi.fps_numerator;
  avifx.strhv.dwLength = min(inFrames, max(0, vi.num_frames - inOffset));
  avifx.strhv.dwSuggestedBufferSize = vi.BMPSize();
  avifx.strhv.dwQuality = unsigned(-1);
  avifx.strhv.rcFrame.right  = (short)vi.width;
  avifx.strhv.rcFrame.bottom = (short)vi.height;
//-----
  avifx.strfv.fcc = ckidSTREAMFORMAT;
  avifx.strfv.cb = sizeof(avifx.video);
//-----
  avifx.video.biSize = sizeof(BITMAPINFOHEADER);
  avifx.video.biWidth = vi.width;
  avifx.video.biHeight = vi.height;
  avifx.video.biPlanes = 1;
  avifx.video.biBitCount = (short)vi.BitsPerPixel();
  avifx.video.biCompression = pixelTypeToFCC(vi.pixel_type);
  avifx.video.biSizeImage = vi.BMPSize();
//-----
// Audio
//-----
  avifx.strla.fcc = FCC('LIST');
  avifx.strla.cb = 4 + sizeof(avifx.strha) + sizeof(avifx.strfa) + sizeof(avifx.audio);
  avifx.strla.fccListType = ckidSTREAMLIST;
//-----
  avifx.strha.fcc = ckidSTREAMHEADER;
  avifx.strha.cb = sizeof(AVISTREAMHEADER) - 8;
  avifx.strha.fccType = streamtypeAUDIO;
  avifx.strha.dwInitialFrames = 1;
  avifx.strha.dwScale = vi.BytesPerAudioSample();
  avifx.strha.dwRate = vi.audio_samples_per_second * vi.BytesPerAudioSample();
  avifx.strha.dwLength = (unsigned)min(vi.AudioSamplesFromFrames(inFrames),
                                   max(0, vi.num_audio_samples - vi.AudioSamplesFromFrames(inOffset)));
  avifx.strha.dwSuggestedBufferSize = vi.BytesPerAudioSample() * avifx.strha.dwLength;
  avifx.strha.dwQuality = unsigned(-1);
  avifx.strha.dwSampleSize = vi.BytesPerAudioSample();
//-----
  avifx.strfa.fcc = ckidSTREAMFORMAT;
  avifx.strfa.cb = sizeof(avifx.audio);
//-----
#define ___ex(audio) ((WAVEFORMATEX*)&(audio))
  ___ex(avifx.audio)->wFormatTag      = (unsigned short)(vi.IsSampleType(SAMPLE_FLOAT) ? WAVE_FORMAT_IEEE_FLOAT : WAVE_FORMAT_PCM);
  ___ex(avifx.audio)->nChannels       = (unsigned short)vi.AudioChannels();
  ___ex(avifx.audio)->nSamplesPerSec  = vi.SamplesPerSecond();
  ___ex(avifx.audio)->nAvgBytesPerSec = vi.SamplesPerSecond() * vi.BytesPerAudioSample();
  ___ex(avifx.audio)->nBlockAlign     = (unsigned short)vi.BytesPerAudioSample();
  ___ex(avifx.audio)->wBitsPerSample  = (unsigned short)(vi.BytesPerChannelSample() * 8);
#undef ___ex
//-----
// ODML
//-----
  avifx.odml.fcc = FCC('LIST');
  avifx.odml.cb = 4 + sizeof(avifx.dmlh);
  avifx.odml.fccListType = ckidODML;
//-----
  avifx.dmlh.fcc = ckidAVIEXTHEADER;
  avifx.dmlh.cb = sizeof(AVIEXTHEADER) - 8;
  avifx.dmlh.dwGrandFrames = inFrames;
//-----
  avifx.junk.fcc = FCC('JUNK');
  avifx.junk.cb = 10240 - sizeof(fileHdr);
//=====
// 00dc - Video chunk header
//=====
  v00dc.fcc = FCC('00dc');
  v00dc.cb = vi.BMPSize();
//=====
// 01wb - Audio chunk header
//=====
  a01wb.fcc = FCC('01wb');
  a01wb.cb = avifx.strha.dwSuggestedBufferSize;
//=====
  const int nAudioBlocks = avifx.strha.dwLength ? 1 : 0;
  videoDataSize = (vi.BMPSize() + sizeof(RIFFCHUNK)) * avifx.strhv.dwLength;
//=====
// MOVI
//=====
  movi.fcc = FCC('LIST');
  movi.cb = sizeof(movi.fccListType) + videoDataSize + (sizeof(a01wb) + a01wb.cb) * nAudioBlocks;
  movi.fccListType = FCC('movi');
//=====
// IDX1
//=====
  idx1DataSize = sizeof(AVIOLDINDEX) + sizeof(idx1->aIndex[0]) * (avifx.strhv.dwLength + nAudioBlocks);
  idx1 = (AVIOLDINDEX *)new char[idx1DataSize];
  idx1->fcc = ckidAVIOLDINDEX;
  idx1->cb = idx1DataSize - 8;
  unsigned i;
  for (i=0; i<avifx.strhv.dwLength; i++) {
    idx1->aIndex[i].dwChunkId = FCC('00dc');
    idx1->aIndex[i].dwFlags   = AVIIF_KEYFRAME;
    idx1->aIndex[i].dwOffset  = 4 + (vi.BMPSize() + sizeof(RIFFCHUNK)) * i;
    idx1->aIndex[i].dwSize    = vi.BMPSize();
  }
  if (nAudioBlocks) {
    idx1->aIndex[i].dwChunkId = FCC('01wb');
    idx1->aIndex[i].dwFlags   = AVIIF_KEYFRAME;
    idx1->aIndex[i].dwOffset  = 4 + videoDataSize;
    idx1->aIndex[i].dwSize    = a01wb.cb;
  }
//=====

  avifx.riff.cb = fileHdrSize - 8 + sizeof(RIFFCHUNK) + movi.cb + sizeof(RIFFCHUNK) + idx1->cb;
}


AvfsAviFile::~AvfsAviFile(void)
{
  delete[] (char*)idx1;
  avs->Release();
}


void AvfsAviFile::AddRef(void)
{
  ASSERT(references);
  references ++;
}


void AvfsAviFile::Release(void)
{
  ASSERT(references);
  if(!--references)
  {
    delete this;
  }
}


inline bool/*all done*/ AvfsAviFile::copyVideo(
  char*        &Buffer,
  unsigned     &fileOffset,
  unsigned     &requestedSize,
  size_t       inSize,
  AvfsLog_*    log,
  bool         &success)
{
  const VideoInfo& vi = avs->GetVideoInfo();
  const unsigned videoChunkSize = sizeof(RIFFCHUNK) + vi.BMPSize();

  // Copy any video data
  while (fileOffset < inSize) {
    int n = frameOffset + fileOffset / videoChunkSize;
    unsigned offset = fileOffset % videoChunkSize;

    // Copy any 00dc data
    if ( copyBuffer(Buffer, offset, requestedSize, sizeof(v00dc), &v00dc) ) break;

    const unsigned size = min(unsigned(vi.BMPSize()) - offset, requestedSize);
    success = success && frameCopy(log, Buffer, n, offset, size);
    Buffer += size;
    fileOffset += size;
    requestedSize -= size;

    if (requestedSize == 0) break;
  }
  fileOffset -= inSize;
  return (requestedSize == 0);
}


inline bool/*all done*/ AvfsAviFile::copyAudio(
  char*        &Buffer,
  unsigned     &fileOffset,
  unsigned     &requestedSize,
  size_t       inSize,
  AvfsLog_*    log,
  bool         &success)
{
  const VideoInfo& vi = avs->GetVideoInfo();

  if (fileOffset < inSize) {
    char temp[maxAlign];
    unsigned size = min(inSize - fileOffset, requestedSize);
    const unsigned align = vi.BytesPerAudioSample();

    uint64_t nsample = vi.AudioSamplesFromFrames(frameOffset) + vi.AudioSamplesFromBytes(fileOffset);

    // deal with ragged head
    const unsigned extra = (align - (unsigned)(fileOffset % align)) % align;
    if (extra > 0) {
      const unsigned esize = min(extra, size);
      success = success && avs->GetAudio(log, temp, nsample, 1);
      nsample += 1;
      memcpy(Buffer, temp+align-extra, esize);
      Buffer += esize;
      fileOffset += esize;
      requestedSize -= esize;
      size -= esize;
    }
    if (requestedSize == 0) return true;

    // do sample aligned bulk of transfer
    const unsigned count = (unsigned)vi.AudioSamplesFromBytes(size);
    success = success && avs->GetAudio(log, Buffer, nsample, count);
    nsample += count;
    Buffer += (unsigned)vi.BytesFromAudioSamples(count);
    fileOffset += size;
    requestedSize -= (unsigned)vi.BytesFromAudioSamples(count);
    size -= (unsigned)vi.BytesFromAudioSamples(count);

    // deal with ragged tail
    if (size > 0) {
      success = success && avs->GetAudio(log, temp, nsample, 1);
      memcpy(Buffer, temp, size);
      Buffer += size;
      fileOffset += size;
      requestedSize -= size;
    }
  }
  fileOffset -= inSize;
  return (requestedSize == 0);
}


bool/*success*/ AvfsAviFile::ReadMedia(
  AvfsLog_* log,
  uint64_t inFileOffset,
  void* buffer,
  size_t inRequestedSize)
{
  // Avfspfm.cpp logic makes some guarantees.
  ASSERT(inRequestedSize);
  ASSERT(inFileOffset < 8 + avifx.riff.cb);
  ASSERT(inFileOffset+inRequestedSize <= 8 + avifx.riff.cb);

  bool success = true;
  unsigned fileOffset = static_cast<unsigned>(inFileOffset);
  unsigned requestedSize = static_cast<unsigned>(inRequestedSize);
  char* Buffer = (char*)buffer;
#if 1
  // Copy any header data
  if ( copyBuffer(Buffer, fileOffset, requestedSize, sizeof(avifx), &avifx) ) return success;

  // Fill any padding data
  if ( fillBuffer(Buffer, fileOffset, requestedSize, avifx.junk.cb) ) return success;

  // Copy any LIST movi data
  if ( copyBuffer(Buffer, fileOffset, requestedSize, sizeof(movi), &movi) ) return success;

  // Copy any video data
  if ( copyVideo(Buffer, fileOffset, requestedSize, videoDataSize, log, success) ) return success;

  if (avifx.strha.dwLength) {
    // Copy any 01wb data
    if ( copyBuffer(Buffer, fileOffset, requestedSize, sizeof(a01wb), &a01wb) ) return success;

    // Copy any audio data samples
    if ( copyAudio(Buffer, fileOffset, requestedSize, a01wb.cb, log, success) ) return success;
  }
    
  // Copy any idx1 data
  if ( copyBuffer(Buffer, fileOffset, requestedSize, idx1DataSize, idx1) ) return success;

  ASSERT(fileOffset == 0);

  return success;
#else
  // Copy any header data
  if (fileOffset < sizeof(fileHdr)) {
    const unsigned size = min(sizeof(fileHdr) - fileOffset, requestedSize);
    memcpy(Buffer, reinterpret_cast<char*>(&avifx)+fileOffset, size);
    Buffer += size;
    fileOffset += size;
    requestedSize -= size;
  }
  if (requestedSize == 0) return success;
  fileOffset -= sizeof(fileHdr);

  // Fill any padding data
  if (fileOffset < avifx.junk.cb) {
    const unsigned size = min(avifx.junk.cb - fileOffset, requestedSize);
    memset(Buffer, '\0', size);
    Buffer += size;
    fileOffset += size;
    requestedSize -= size;
  }
  if (requestedSize == 0) return success;
  fileOffset -= avifx.junk.cb;

  // Copy any LIST movi data
  if (fileOffset < sizeof(RIFFLIST)) {
    const unsigned size = min(sizeof(RIFFLIST) - fileOffset, requestedSize);
    memcpy(Buffer, reinterpret_cast<char*>(&movi)+fileOffset, size);
    Buffer += size;
    fileOffset += size;
    requestedSize -= size;
  }
  if (requestedSize == 0) return success;
  fileOffset -= sizeof(RIFFLIST);

  const VideoInfo& vi = avs->GetVideoInfo();
  const unsigned videoChunkSize = sizeof(RIFFCHUNK) + vi.BMPSize();

  // Copy any video data
  while (fileOffset < videoDataSize) {
    int n = frameOffset + fileOffset / videoChunkSize;
    unsigned offset = fileOffset % videoChunkSize;

    // Copy any 00dc data
    if (offset < sizeof(RIFFCHUNK)) {
      const unsigned size = min(sizeof(RIFFCHUNK) - offset, requestedSize);
      memcpy(Buffer, reinterpret_cast<char*>(&v00dc)+offset, size);
      Buffer += size;
      fileOffset += size;
      offset     += size;
      requestedSize -= size;
    }
    if (requestedSize == 0) break;
    offset -= sizeof(RIFFCHUNK);
    
    if (offset < unsigned(vi.BMPSize())) {
      const unsigned size = min(unsigned(vi.BMPSize()) - offset, requestedSize);
      success = success && frameCopy(log, Buffer, n, offset, size);
      Buffer += size;
      fileOffset += size;
      requestedSize -= size;
    }
    if (requestedSize == 0) break;
  }
  if (requestedSize == 0) return success;
  fileOffset -= videoDataSize;

  if (avifx.strha.dwLength) {
    // Copy any 01wb data
    if (fileOffset < sizeof(RIFFCHUNK)) {
      const unsigned size = min(sizeof(RIFFCHUNK) - fileOffset, requestedSize);
      memcpy(Buffer, reinterpret_cast<char*>(&a01wb)+fileOffset, size);
      Buffer += size;
      fileOffset += size;
      requestedSize -= size;
    }
    if (requestedSize == 0) return success;
    fileOffset -= sizeof(RIFFCHUNK);
      
    // Copy any audio data samples
    if (fileOffset < a01wb.cb) {
      char temp[maxAlign];
      unsigned size = min(a01wb.cb - fileOffset, requestedSize);
      const unsigned align = vi.BytesPerAudioSample();

      uint64_t nsample = vi.AudioSamplesFromFrames(frameOffset) + vi.AudioSamplesFromBytes(fileOffset);

      // deal with ragged head
      const unsigned extra = (align - (unsigned)(fileOffset % align)) % align;
      if (extra > 0) {
        const unsigned esize = min(extra, size);
        success = success && avs->GetAudio(log, temp, nsample, 1);
        nsample += 1;
        memcpy(Buffer, temp+align-extra, esize);
        Buffer += esize;
        fileOffset += esize;
        requestedSize -= esize;
        size -= esize;
      }
      if (requestedSize == 0) return success;

      // do sample aligned bulk of transfer
      const unsigned count = (unsigned)vi.AudioSamplesFromBytes(size);
      success = success && avs->GetAudio(log, Buffer, nsample, count);
      nsample += count;
      Buffer += (unsigned)vi.BytesFromAudioSamples(count);
      fileOffset += size;
      requestedSize -= (unsigned)vi.BytesFromAudioSamples(count);
      size -= (unsigned)vi.BytesFromAudioSamples(count);

      // deal with ragged tail
      if (size > 0) {
        success = success && avs->GetAudio(log, temp, nsample, 1);
        memcpy(Buffer, temp, size);
        Buffer += size;
        fileOffset += size;
        requestedSize -= size;
      }
    }
    if (requestedSize == 0) return success;
    fileOffset -= a01wb.cb;
  }
    
  // Copy any idx1 data
  if (fileOffset < idx1DataSize) {
    const unsigned size = min(idx1DataSize - fileOffset, requestedSize);
    memcpy(Buffer, reinterpret_cast<char*>(idx1)+fileOffset, size);
    Buffer += size;
    fileOffset += size;
    requestedSize -= size;
  }
  if (requestedSize == 0) return success;
  fileOffset -= idx1DataSize;
    
  ASSERT(fileOffset == 0);

  return success;
#endif
}


uint64_t AvfsAviFile::fileSize(void)
{
  return avifx.riff.cb + sizeof(RIFFCHUNK);
};


bool/*success*/ AvfsAviFile::frameCopy(
  AvfsLog_* log,
  char* buffer,
  int n,
  unsigned offset,
  unsigned size)
{
  bool success = true;
  PVideoFrame frame = avs->GetFrame(log, n, &success);
  if (!success) return false;

  if ( copyPlane(buffer, offset, size, frame, PLANAR_Y, 3) ) return true;
  if ( copyPlane(buffer, offset, size, frame, PLANAR_V, 1) ) return true;
  if ( copyPlane(buffer, offset, size, frame, PLANAR_U, 1) ) return true;

  ASSERT(size == 0);

  return true;
}


void AvfsAviMediaInit(
  AvfsLog_* log,
  Avisynther_* avs,
  AvfsVolume_* volume)
{
  ASSERT(log && avs && volume);

  // Get shape and size info
  const VideoInfo& vi = avs->GetVideoInfo();

  if (!vi.HasVideo() && !vi.HasAudio()) return; // No video or audio streams

  if (vi.BytesPerAudioSample() > AvfsAviFile::maxAlign) {
    log->Printf(L"AvfsAviMediaInit: Unsupported BytesPerAudioSample(%d)\r\n", vi.BytesPerAudioSample());
    return;
  }

  unsigned headDataBytes = fileHdrSize + sizeof(RIFFLIST) + sizeof(AVIOLDINDEX);
  uint64_t bytes = 0;
  int max_frames = 0;

  if (vi.HasVideo()) {
    bytes = uint64_t(vi.num_frames) * (sizeof(RIFFCHUNK) + vi.BMPSize() + sizeof(((AVIOLDINDEX*)(0))->aIndex[0]));
    max_frames = vi.num_frames;
  }

  if (vi.HasAudio()) {
    bytes += vi.BytesFromAudioSamples(vi.num_audio_samples);
    headDataBytes += sizeof(RIFFCHUNK) + sizeof(((AVIOLDINDEX*)(0))->aIndex[0]);
    const uint64_t scale = UInt32x32To64(vi.fps_denominator, unsigned(vi.audio_samples_per_second));
    max_frames = max(max_frames, int((vi.num_audio_samples * vi.fps_numerator + scale - 1) / scale)); // Ceiling of
  }

  const unsigned maxDataBytes = 0x3fffffff - headDataBytes;
  const unsigned nfiles = unsigned((bytes+maxDataBytes-1) / maxDataBytes);
  const int num_frames = (max_frames + nfiles - 1 ) / nfiles;

  // Fit in a 4GB avi ?
  if (bytes <= 0xfffffffe - headDataBytes) {
    AvfsAviFile* avi = new(std::nothrow) AvfsAviFile(avs, 0, max_frames);
    if(avi)
    {
      static const size_t maxNameChars = 300;
      wchar_t name[maxNameChars];
      ssformat(name, maxNameChars,  L"%s.avi", volume->GetMediaName());
      volume->CreateMediaFile(avi, name, avi->fileSize());
      avi->Release();
    }
  }

  // A series of <= 1GB avi's
  if (nfiles > 1) {
    for (unsigned i=0; i<nfiles; i++) {
      int frames = min(num_frames, max_frames);
      max_frames -= frames;

      AvfsAviFile* avi = new(std::nothrow) AvfsAviFile(avs, num_frames*i, frames);
      if(avi)
      {
        static const size_t maxNameChars = 300;
        wchar_t name[maxNameChars];
        ssformat(name, maxNameChars, L"%s.%02i.avi", volume->GetMediaName(), i);
        volume->CreateMediaFile(avi, name, avi->fileSize());
        avi->Release();
      }
    }
  }
}
